// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020-2021 Florian Schmaus, Florian Fischer
#include "test-runner.hpp"

#include <cstdlib>
#include <iostream>

#include "Fiber.hpp"
#include "Runtime.hpp"
#include "lib/sync/Semaphore.hpp"

static void invokeTest(emper::lib::sync::Semaphore* successSem) {
	emperTest();

	successSem->notify();
}

auto testMain() -> int {
	if (!&emperTest) {
		std::cerr << "ERROR: The emperTest() method is not defined.";
		return EXIT_FAILURE;
	}

	Runtime runtime;
	emper::lib::sync::Semaphore successSem;

	Fiber* alphaFiber = Fiber::from([&successSem] { invokeTest(&successSem); });

	runtime.scheduleFromAnywhere(*alphaFiber);

	successSem.wait();

	return EXIT_SUCCESS;
}
